include "FixedCode.inc"

ext FixedCode, InitVram_, SoundHandler_, InitSound_

Port31Save equ 0e658h
Port33Save equ 0e669h

dseg
old31: defb 0
old33: defb 0
PrevSync: defb 0
TimerCount: defb 0 public TimerCount

cseg
Init_: public  Init_
    ld hl,FixedCode
    ld de,FixedCode_start
    ld bc,FixedCode_size
    ldir

	xor a
	out (68h),a
	out (0e6h),a

    ld a,(Port31Save)
	ld (old31),a
	ld a,01dh
    out (31h),a
	ld (Port31Save),a

    ld a,(Port33Save)
	ld (old33),a
	ld a,084h
    out (33h),a
	ld (Port33Save),a

    call InitSound_
	call InitVram_
ret


Fin_: public  Fin_
    ld a,(old31)
    out (31h),a
	ld (Port31Save),a

    ld a,(old33)
    out (33h),a
	ld (Port33Save),a
ret	


PollVSync_: public PollVSync_
	push af
		in a,(40h)
		and 20h
        if nz
            ld a,(PrevSync)
            or a
            call z,Handler
            ld a,20h
        endif
        ld (PrevSync),a
    pop af
ret


Handler: public Handler
    call SoundHandler_
    push hl
        ld hl,TimerCount
        inc (hl)
    pop hl
ret


WaitTimer_:
    public WaitTimer_
    push af | push de
        ld e,a
        do
            call PollVSync_
            ld a,(TimerCount)
            cp e
        while c | wend
        ; di
            xor a
            ld (TimerCount),a
        ; ei
    pop de | pop af
ret
